Bug 503824 - x86_64 upgrade in KVM hangs (OOM) with 512MB RAM + encrypted root
x86_64 upgrade in KVM hangs (OOM) with 512MB RAM + encrypted root
Product: Fedora
Classification: Fedora
Component: anaconda (Show other bugs)
All Linux
low Severity medium
: ---
: ---
Assigned To: Anaconda Maintenance Team
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2009-06-02 17:30 EDT by Will Woods
Modified: 2016-05-31 16:16 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2010-06-28 08:47:46 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Will Woods 2009-06-02 17:30:45 EDT
When upgrading an x86_64 Fedora 10 VM with LUKS-encrypted root + swap partitions, F11 anaconda hangs while upgrading glibc-common. 

Raising the available RAM for the VM to 768MB or 1024MB seems to allow the upgrade to finish successfully.
Comment 1 Will Woods 2009-06-03 00:57:42 EDT
With a previous OOM bug, using text mode (e.g. by putting 'text' on the boot commandline) would allow the upgrade to complete successfully. Might be a usable workaround here - I'll test it and see.
Comment 2 Mark McLoughlin 2009-06-04 09:09:25 EDT
See also bug #480826 and bug #474116
Comment 3 Will Woods 2009-06-04 10:48:04 EDT
Note that I'm performing a preupgrade, which causes anaconda to keep install.img in memory. But it's also using tmpfs for /tmp (rather than ramfs), which should allow at least *some* of it to be swapped out. I'll attempt an upgrade using media later to see if that helps anything.

Using 'text' allows the (pre)upgrade to (eventually) complete. Otherwise I see OOM kills happening in syslog and the installation either hangs or crashes (depending on what gets OOM killed). 

Leading up to that point, I note that anaconda's heap (in /proc/$pid/maps) is somewhere between 150-200MB. That seems like a lot, but I guess x86_64 python is notorious for abusing the heap.

The bugs in comment #2 both concern *installations* rather than upgrades. I believe the memory requirements for fresh installs to be somewhat lower than upgrades, so it's possible that the change to tmpfs for /tmp might fix those.
Comment 4 Will Woods 2009-06-04 12:09:24 EDT
Confirmed that the problem isn't preupgrade-specific: upgrading using a DVD also runs out of memory and dies when the kernel starts killing things.
Comment 5 Chris Lumens 2009-06-09 14:57:08 EDT
Is the swap partition even getting used?  I don't see how there's really much we can do except raise the memory requirements and no one likes that.
Comment 6 Will Woods 2009-06-10 09:09:49 EDT
It's active and there are definitely some things swapped out - but python's heap (which is maybe unswappable?) is around 200MB as the failure approaches.
Comment 7 Chris Lumens 2009-10-07 21:43:08 EDT
I don't really have any good suggestions here other than to bump the amount of memory you're providing to the VM.  It's well known that upgrades are especially hard on memory requirements, as is x86_64.  And yes you're right, running with the graphical environment means you've got all that stuff sitting in memory consuming space too.

It's probably worth retesting this at some point, though if you're still seeing it I don't know that we can do anything more besides put this into WONTFIX.  We're definitely not going to get around to a serious memory usage audit with anaconda any time soon.
Comment 8 Bug Zapper 2010-04-27 10:37:49 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
Comment 9 Bug Zapper 2010-06-28 08:47:46 EDT
Fedora 11 changed to end-of-life (EOL) status on 2010-06-25. Fedora 11 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.